# Esercizio Cariche
# DATI
param n := 5;
set N := 1..n;

# VARIABILI
var x {N};
var y {N};
var z {N};
var distanza {i in N, j in N: i<j} >=0;

# VINCOLI
subject to Sfera {i in N}:
  x[i]^2 + y[i]^2 + z[i]^2 = 1;

subject to Def_distanze {i in N, j in N: i<j}:
  distanza[i,j]^2 = (x[i]-x[j])^2 + (y[i]-y[j])^2 + (z[i]-z[j])^2;

# OBIETTIVO
minimize w: sum {i in N, j in N: i<j} 1 / distanza[i,j];  

data;
var:    x   y   z :=
1       0   1   0
2       1   0   0
3       0   0   1
4       0.7 0.7 0
5       0   0.7 0.7;

end;
